/*
 * Copyright(C) 1999-2008  << >>
 *
 *    , 
 *    << >>.
 *
 *        ,
 * ,    ,
 *     ,
 * ,     
 *     
 *     << >>.
 */
package com.digt.trusted.cms.test;

import java.io.ByteArrayInputStream;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.FileInputStream;
import java.security.KeyPair;
import java.security.Provider;
import java.security.Security;
import java.security.cert.CertStore;
import java.security.cert.X509Certificate;
import java.util.Arrays;
import java.util.Collection;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Iterator;

import com.digt.trusted.asn1.ASN1InputStream;
import com.digt.trusted.asn1.ASN1Set;
import com.digt.trusted.asn1.DEREncodable;
import com.digt.trusted.asn1.DERObject;
import com.digt.trusted.asn1.cms.Attribute;
import com.digt.trusted.asn1.cms.ContentInfo;
import com.digt.trusted.asn1.cms.AttributeTable;

import com.digt.trusted.cms.CMSSignedData;
import com.digt.trusted.cms.SignerInformation;
import com.digt.trusted.cms.SignerInformationStore;

import com.digt.trusted.util.encoders.Base64;
import com.digt.trusted.util.addon.TD_Sign;

/*
 *        IDE
 */
public class SignedDataAttributesTest_tj {

    boolean DEBUG = true;
    String signDN;
    KeyPair signKP;
    X509Certificate signCert;

    public static void main(String[] args) {
//        Security.addProvider(new DIGTProvider());
        SignedDataAttributesTest_tj st = new SignedDataAttributesTest_tj();
        st.setUp();
        st.testPKCS7();
    }

    void log(Exception _ex) {
        if (DEBUG) {
            _ex.printStackTrace();
        }
    }

    void log(String _msg) {
        if (DEBUG) {
            System.out.println(_msg);
        }
    }

    public void setUp() {
        signDN = "CN=Developer, E=info@digt.ru, O=DIGT, C=RU";
    }

    void ASN1Set_About(Attribute attr, String prefix) {
        String dAs;
        String prefix2 = "AttributeTable_About: ";
        dAs = TD_Sign.Attribute2String(attr);
        if (dAs != null) {
            System.out.println(prefix + prefix2 + "Value for oid (" + attr.getAttrType().getId() + ") = '" + dAs + "'");
        } else {
            ASN1Set v = attr.getAttrValues();
            System.out.println(prefix + prefix2 + "Values for oid (" + attr.getAttrType().getId() + ") = ");
            for (int i = 0; i < v.size(); i++) {
                DERObject obj = v.getObjectAt(i).getDERObject();
                dAs = obj.toString();
                dAs = dAs.substring(0, Math.min(30, dAs.length())) + " ...";
                System.out.println(prefix + prefix2 + "Value[" + (i + 1) + "] = " + dAs);
            }
        }
    }

    void AttributeTable_About(AttributeTable table, String prefix) {
        if (table == null) {
            System.out.println(prefix + "AttributeTable_About: None attributes!!!");
            return;
        }
        /* Code for bc
        ASN1EncodableVector asn_table;
        asn_table = table.toASN1EncodableVector();
         */
        Hashtable asn_table = table.toHashtable();
        //Enumeration en = asn_table.keys();
        Enumeration en = asn_table.elements();
        while (en.hasMoreElements()) {
            Object i = en.nextElement();
            //System.out.println("AttributeTable_About (Hashtable): key = "+i.toString()+" Value = "+asn_table.get(i).toString() );

            DEREncodable dO = (DEREncodable) i;
            //DEREncodable dO = (DEREncodable) asn_table.get(i);
            Attribute atr = Attribute.getInstance(dO);
            ASN1Set_About(atr, prefix);

        }
    }

    void SignerInformatiom_About(CMSSignedData sig, SignerInformation signer, String prefix) {
        String prefix2 = "Signer_About: ";
        String prefix3 = "SignedAttribute_About: ";
        /*
         * bc
        System.out.println(prefix + "SignerInformatiom_About: Version = " + signer.getVersion());
         */
        System.out.println(prefix + prefix2 + "Issuer  = " + signer.getSID().getIssuerAsString());
        System.out.println(prefix + prefix2 + "Digest Algoritm OID =" + signer.getDigestAlgOID());
        System.out.println(prefix + prefix2 + "Encryption Algoritm OID =" + signer.getEncryptionAlgOID());
        String signOid = signer.getDigestAlgOID() + "with" + signer.getEncryptionAlgOID();
        System.out.println(prefix + prefix2 + "Signature Algoritm = " + signOid);

        //MessageDigest md = MessageDigest.getInstance(signer.getDigestAlgOID());
        //Provider provider = md.getProvider(); //error

        //Provider[] providers = Security.getProviders("MessageDigest." + signer.getDigestAlgOID());
        Provider[] providers = Security.getProviders("Signature." + signOid);
        Provider provider;
        for (int i = 0; i < providers.length; i++) {
            provider = providers[i];
            String providerName = provider.getName();
            System.out.println(prefix + prefix2 + "Provider[i]=" + providerName);
        }
        provider = providers[0];
        String providerName = provider.getName();

        AttributeTable u_table = signer.getUnsignedAttributes();
        System.out.println(prefix + prefix2 + "UnsignedAttributes ----------- ");
        AttributeTable_About(u_table, prefix);
        AttributeTable s_table = signer.getSignedAttributes();
        System.out.println(prefix + prefix2 + "SignedAttributes ----------- ");
        AttributeTable_About(s_table, prefix);
        System.out.println(prefix + prefix2 + "SignedAttributes End ------- ");

        System.out.println(prefix + prefix3 + "TD_Sign.GetCreateTime(s_table) = '"
                + TD_Sign.GetCreateTime(s_table) + "'");

        System.out.println(prefix + prefix3 + "TD_Sign.GetComment(s_table) = '"
                + TD_Sign.GetComment(s_table) + "'");
        System.out.println(prefix + prefix3 + "TD_Sign.GetResourceId(s_table) = '"
                + TD_Sign.GetResourceId(s_table) + "'");
        System.out.println(prefix + prefix3 + "TD_Sign.GetUsingOID(s_table) = '"
                + TD_Sign.GetUsingOID(s_table) + "'");

        try {
            //     ,           
            CertStore certs = sig.getCertificatesAndCRLs("Collection", providerName);
            //     
            Collection certCollection = certs.getCertificates(signer.getSID());
            Iterator certIt = certCollection.iterator();
            X509Certificate cert = (X509Certificate) certIt.next();

            /*
             *  .
             */
            System.out.println(prefix + prefix2 + "Subject  = " + cert.getSubjectDN());
            if (signer.verify(cert, providerName)) {
                System.out.println(prefix + prefix2 + "Sign verified!!");
            }
        } catch (Exception ex) {
            System.out.println(prefix + prefix2 + "Sign not verified: " + ex.getLocalizedMessage()+ "!!!");
            //ex.printStackTrace();
        }

        /*
         * bc
        SignerInformationStore co_signer = signer.getCounterSignatures();
        int size = co_signer.size();
        System.out.println(prefix + prefix2 + "co-signers count = " + size);
         */
        System.out.println(prefix + "=========");
/*
 * bc
        SignerInformationStore co_signer = signer.getCounterSignatures();
        int size = co_signer.size();
        System.out.println(prefix + "SignerInformatiom_About: co-signers count = " + size);
        if (size > 0) {
            //     
            SignerInformationStore_About(sig, co_signer, prefix+" Co-signers : ");
        }
 */
    } //SignerInformatiom_About

    void SignerInformationStore_About(CMSSignedData sig, SignerInformationStore signers, String prefix) {

        System.out.println(prefix + "SignerStore_About: Count signers = " + signers.size());

        //    
        Collection c = signers.getSigners();
        Iterator it = c.iterator();

        //   
        while (it.hasNext()) {
            //    
            SignerInformation signer = (SignerInformation) it.next();
            SignerInformatiom_About(sig, signer, prefix);
        }
    }

    void CMSSignedData_About(CMSSignedData sig, String prefix) {
        //   
        /*
         * bc
        System.out.println(prefix + "Version = " + sig.getVersion());
        System.out.println(prefix + "ContentInfo Type = " + sig.getContentInfo().getContentType().getId());
         */
        System.out.println(prefix + "Signed Content Type OID= " + sig.getSignedContentTypeOID());
    }

    String getStringFromFile(String inFile) {
        String s = "";
        try {
            BufferedReader dataIn = new BufferedReader(
                    new InputStreamReader(new FileInputStream(inFile)));

            String buf = null;
            while ((buf = dataIn.readLine()) != null) {
                s += buf;
            }
            dataIn.close();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        return s;
    }

    private byte[] getBytesFromFile(String pFile) {
        int sl = 0,
                count = 0;
        byte[] b = new byte[0];
        try {
            FileInputStream inFile = new FileInputStream(pFile);
            // ,     
            int bytesAvailable = 0;
            while ((bytesAvailable = inFile.available()) != 0) {
                //   
                b = Arrays.copyOf(b, bytesAvailable + sl);
                count = inFile.read(b, sl, bytesAvailable);
                sl += count;
            }
            inFile.close();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        return b;
    }

    public void testPKCS7() {

        //Security.addProvider(new DIGTProvider());

        byte[] sigBytes;
        //String sigData = getStringFromFile("data/attrs_test.txt.b64.sig");
        //byte[] sigBytes = Base64.decode(sigData);

        byte [] sigData = getBytesFromFile("data/attrs_test.txt.b64.sig");
        if (sigData[0] == 48) {
            //DER-encoding
            sigBytes = sigData;
        } else {
            //Base64-encoding
            sigBytes = Base64.decode(sigData);
        }

        ByteArrayInputStream byteIn = new ByteArrayInputStream(sigBytes);
        ASN1InputStream aIn = new ASN1InputStream(byteIn);

        CMSSignedData sig = null;
        //CMSProcessable data = new CMSProcessableByteArray(test_data.getBytes("UTF-16LE"));
        // CMS   ASN 
        //CMSSignedData sig = new CMSSignedData(data,ContentInfo.getInstance(aIn.readObject()));
        try {

            //     data  
            sig = new CMSSignedData(ContentInfo.getInstance(aIn.readObject()));
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        CMSSignedData_About(sig,"CMSSignedData_About: ");

        //     
        SignerInformationStore_About(sig, sig.getSignerInfos(), " Signers : ");

    }
}
