/*
* Copyright(C) 1999-2008  << >>
*
*    , 
*    << >>.
*
*        ,
* ,    ,
*     ,
* ,     
*     
*     << >>.
*/

package com.digt.trusted.cms.test.bc;

import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.security.KeyPair;
import java.security.Provider;
import java.security.Security;
import java.security.cert.CertStore;
import java.security.cert.CollectionCertStoreParameters;
import java.security.cert.X509Certificate;
import java.security.Key;
import java.security.KeyStore;
import java.security.KeyStoreException;
import java.security.Provider.Service;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.Set;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

import org.bouncycastle.asn1.ASN1InputStream;
import org.bouncycastle.asn1.cms.AttributeTable;
import org.bouncycastle.asn1.cms.ContentInfo;
import org.bouncycastle.asn1.cms.EnvelopedData;
import org.bouncycastle.asn1.pkcs.PKCSObjectIdentifiers;
import org.bouncycastle.cms.CMSProcessable;
import org.bouncycastle.cms.CMSProcessableByteArray;
import org.bouncycastle.cms.CMSSignedData;
import org.bouncycastle.cms.CMSSignedDataGenerator;
import org.bouncycastle.cms.CMSEnvelopedData;
import org.bouncycastle.cms.CMSEnvelopedDataGenerator;
import org.bouncycastle.cms.RecipientId;
import org.bouncycastle.cms.RecipientInformation;
import org.bouncycastle.cms.RecipientInformationStore;
import org.bouncycastle.cms.SignerId;
import org.bouncycastle.cms.SignerInformation;
import org.bouncycastle.cms.SignerInformationStore;

import com.digt.trusted.jce.test.KeyPairAndCertificateUtil;

public class EnvelopedAndSignedDataTest_bc
        extends TestCase
{

     /*
    *
    *  VARIABLES
    *
    */

    boolean DEBUG = true;
    String          signDN1;
    KeyPair         signKP1;
    X509Certificate signCert1;

    String          signDN2;
    KeyPair         signKP2;
    X509Certificate signCert2;

    String          testerDN1;
    KeyPair         testerKP1;
    X509Certificate testerCert1;

    String          testerDN2;
    KeyPair         testerKP2;
    X509Certificate testerCert2;

    String alias=null;
    char[] pass = "11111111".toCharArray();
    String prov = "DIGT";

    /*
    *
    *  INFRASTRUCTURE
    *
    */

    public EnvelopedAndSignedDataTest_bc(String name) {
        super(name);
    }

    public static void main(String args[]) {

        junit.textui.TestRunner.run(EnvelopedAndSignedDataTest_bc.class);
    }

    public static Test suite() {
        return new TestSuite(EnvelopedAndSignedDataTest_bc.class);
    }

    void log(Exception _ex) {
        if(DEBUG) {
            _ex.printStackTrace();
        }
    }

    void log(String _msg) {
        if(DEBUG) {
            System.out.println(_msg);
        }
    }

    public void setUp()
    {
        signDN1 = "CN=Developer1, E=info@digt.ru, O=DIGT, C=RU";
        signDN2 = "CN=Developer2, E=info@digt.ru, O=DIGT, C=RU";
        testerDN1 = "CN=Tester1, E=info@digt.ru, O=DIGT, C=RU";
        testerDN2 = "CN=Tester2, E=info@digt.ru, O=DIGT, C=RU";
    }

    public void tearDown() {

    }

    private byte[] getBytesFromFile(String pFile) {
        int sl = 0,
                count = 0;
        byte[] b = new byte[0];
        try {
            FileInputStream inFile = new FileInputStream(pFile);
            // ,     
            int bytesAvailable = 0;
            while ((bytesAvailable = inFile.available()) != 0) {
                //   
                b = Arrays.copyOf(b, bytesAvailable + sl);
                count = inFile.read(b, sl, bytesAvailable);
                sl += count;
            }
            inFile.close();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        return b;
    }

    private String getStringFromFile(String inFile) {
        String s = "";
        try {
            BufferedReader dataIn = new BufferedReader(
                    new InputStreamReader(new FileInputStream(inFile)));

            String buf = null;
            while ((buf = dataIn.readLine()) != null) {
                s += buf;
            }
            dataIn.close();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        return s;
    }

    /*
    *  TESTS
    */

    //      "GOST3411WithGOST3410"
//    public void testGOST3411WithGOST3410()
//    {
//        try
//        {
//
//            //      
//            String   _sigAlg   = "GOST3411WithGOST3410";
//            signKP   = KeyPairAndCertificateUtil.makeGOST3410KeyPair();
//            signCert = KeyPairAndCertificateUtil.makeCertificate(signKP, signDN, signKP, signDN, _sigAlg);
//
//            //  
//            // 
//            CMSProcessable      msg = new CMSProcessableByteArray("Test Data".getBytes());
//            // CMS 
//            CMSSignedDataGenerator gen = new CMSSignedDataGenerator();
//            // 
//            gen.addSigner(signKP.getPrivate(), signCert, CMSSignedDataGenerator.DIGEST_GOST3411);
//
//            //    CRL    ,        CRL ,       ,    .
//            ArrayList           certList = new ArrayList();
//            certList.add(signCert);
//            CertStore           certs = CertStore.getInstance("Collection",
//                    new CollectionCertStoreParameters(certList), "DIGT");
//            gen.addCertificatesAndCRLs(certs);
//
//            //
//            CMSSignedData s = gen.generate(msg, true, "DIGT");
//            //  
//            ByteArrayInputStream bIn = new ByteArrayInputStream(s.getEncoded());
//            //    .
//            /*DataOutputStream out_msg = new DataOutputStream( new BufferedOutputStream(new FileOutputStream("c:\\signed_gost.p7s.")));
//            for (int i = 0; i != bIn.length; i++) out_msg.writeByte(bIn[i]);
//            out_msg.close();*/
//
//            //  
//            // ASN   
//            ASN1InputStream      aIn = new ASN1InputStream(bIn);
//
//            // CMS   ASN 
//            s = new CMSSignedData(ContentInfo.getInstance(aIn.readObject()));
//
//            //     ,           
//            certs = s.getCertificatesAndCRLs("Collection", "DIGT");
//
//            //    
//            SignerInformationStore  signers = s.getSignerInfos();
//            Collection              c = signers.getSigners();
//            Iterator                it = c.iterator();
//            //   
//            while (it.hasNext())
//            {
//                //    
//                SignerInformation   signer = (SignerInformation)it.next();
//                //     
//                Collection          certCollection = certs.getCertificates(signer.getSID());
//                Iterator        certIt = certCollection.iterator();
//                X509Certificate cert = (X509Certificate)certIt.next();
//                // .
//                log("Signature verification status = " + signer.verify(cert, "DIGT"));
//                assertEquals(true, signer.verify(cert, "DIGT"));
//            }
//        }
//        catch(Exception ex)
//        {
//            log(ex);
//            fail();
//        }
//    }

    private CMSSignedData AddCounterSigners(
            CMSSignedData s,
            SignerInformation signer,
            ArrayList SignersList,
            boolean allin1) {

        if (SignersList.isEmpty() || signer == null) {
            return s;
        }

        ArrayList csNew = null;
        AttributeTable signer_at = null;
        SignerInformationStore sis = null;
        SignerInformation signer1 = null;
        SignerInformation origSigner = null;

        SignerId orig_SID = signer.getSID();
        try {
            //        .
            ArrayList certList = new ArrayList();
            CertStore s_orig = s.getCertificatesAndCRLs("Collection", prov);
            //    
            certList.addAll(s_orig.getCRLs(null));
            //  
            certList.addAll(s_orig.getCertificates(null));
            //  CMS-
            CMSSignedDataGenerator gen = new CMSSignedDataGenerator();
            //  
            for (int i = 0; i < ((allin1)?SignersList.size() / 2:1); i++) {
                gen.addSigner(((KeyPair) SignersList.get(2 * i)).getPrivate(),
                        (X509Certificate) SignersList.get(2 * i + 1),
                        CMSSignedDataGenerator.DIGEST_GOST3411);
                certList.add((X509Certificate) SignersList.get(2 * i + 1));
            }
            //      
            CertStore certs = CertStore.getInstance("Collection", new CollectionCertStoreParameters(certList), prov);
            //gen.addCertificatesAndCRLs(certs);

            //         
            s = CMSSignedData.replaceCertificatesAndCRLs(s, certs);
            //  
            sis = s.getSignerInfos();
            origSigner = sis.get(orig_SID);
            if (origSigner == null) {
                return s; //  
            }
            SignerInformationStore cs1 = gen.generateCounterSigners(origSigner, prov);
            signer1 = SignerInformation.addCounterSigners(origSigner, cs1);
            SignerInformationStore cs = signer1.getCounterSignatures();
            //  
            Collection csSigners = cs.getSigners();
            Iterator it = csSigners.iterator();
            while (it.hasNext()) {
                SignerInformation cSigner = (SignerInformation) it.next();
                Collection certCollection = certs.getCertificates(cSigner.getSID());
                Iterator certIt = certCollection.iterator();
                X509Certificate cert = (X509Certificate) certIt.next();
                assertNull(cSigner.getSignedAttributes().get(PKCSObjectIdentifiers.pkcs_9_at_contentType));
                assertEquals(true, cSigner.verify(cert, prov));
            }
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        /*
         *      ,
         *   .
         * (   ?!)
         *
         */
        signer_at = signer1.getUnsignedAttributes();
        /*
        AttributeTable origSigner_at = origSigner.getUnsignedAttributes();
        if (origSigner_at != null) {
            ASN1EncodableVector origSigner_atv = origSigner_at.toASN1EncodableVector();
            ASN1EncodableVector signer_atv = signer_at.toASN1EncodableVector();
            for (int i = 0; i < signer_atv.size(); i++) {
                origSigner_atv.add(signer_atv.get(i));
            }
            signer_at = new AttributeTable(origSigner_atv);
        }
         */
        Iterator it = sis.getSigners().iterator();
        //      .
        csNew = new ArrayList();
        while (it.hasNext()) {
            SignerInformation ss = (SignerInformation) it.next();
            if (orig_SID.equals(ss.getSID())) {
                ss = SignerInformation.replaceUnsignedAttributes(signer, signer_at);
            }
            csNew.add(ss);
        }
        /*
         *         .
         */
        SignerInformationStore sis_new = new SignerInformationStore(csNew);
        s = CMSSignedData.replaceSigners(s, sis_new);
        //   
        if (allin1) {
            return s;
        } else {
            SignersList.remove(1);
            SignersList.remove(0);
            return AddCounterSigners(s,signer,SignersList,allin1);
        }
    }

    private Key RecipientKeyInStore(RecipientId rid) {
        //      KeyStore
        Key sk = null;
        KeyStore kstore = null;
        this.alias = null;
        Provider[] pr = Security.getProviders();
        for (int i = 0; i < pr.length; i++) {
            Iterator it_prs = ((Set) pr[i].getServices()).iterator();
            while (it_prs.hasNext()) {
                Service pr_s = (Service) it_prs.next();
                if (!pr_s.getType().equals("KeyStore")) {
                    continue;
                }

                try {
                    kstore = KeyStore.getInstance(pr_s.getAlgorithm(), pr[i].getName());
                    InputStream store_stream = new ByteArrayInputStream("".getBytes("UTF-8"));
                    if (pr_s.getAlgorithm().equals("CryptoProCSPKeyStore")) {
                        store_stream = new ByteArrayInputStream("CurrentUser".getBytes("UTF-8"));
                    } else {//???   
                    }
                    kstore.load(store_stream, null);
                    //   
                    this.alias = RecipientKeyAlias(kstore, rid);
                    if (this.alias == null) {
                        continue;
                    }

                    //   
                    this.prov = pr[i].getName();

                    sk = kstore.getKey(this.alias, this.pass);
                    return sk;
                } catch (Exception ex) {
                }
            }
        }
        return sk;
    }

    private static String RecipientKeyAlias(KeyStore kstore, RecipientId rid)
            throws KeyStoreException {
        String al = null;
        //      
        for (Enumeration aliases = kstore.aliases(); aliases.hasMoreElements();) {
            String alias_ = (String) aliases.nextElement();
            X509Certificate Cert = (X509Certificate) kstore.getCertificate(alias_);
            if (Cert.getIssuerX500Principal().equals(rid.getIssuer()) && Cert.getSerialNumber().equals(rid.getSerialNumber())) {
//                if (kstore.isKeyEntry(alias_)) {
                    al = alias_;
                    break;
//                }
            }
        }
        return al;
    }

    /*
     *       "GOST3411WithGOST3410EL"
     *    ,     
     */
    public void testGOST3411WithGOST3410EL() {
        log("Start testGOST3411WithGOST3410EL()...");
        String _sigAlg = "GOST3411WithGOST3410EL";

        try {
            CMSProcessable msg = new CMSProcessableByteArray("Test Data".getBytes());

            signKP1 = KeyPairAndCertificateUtil.makeGOSTELDHKeyPair();

            signCert1 = KeyPairAndCertificateUtil.makeCertificate(signKP1, signDN1, signKP1, signDN1, _sigAlg);
            signKP2 = KeyPairAndCertificateUtil.makeGOSTELDHKeyPair();
            signCert2 = KeyPairAndCertificateUtil.makeCertificate(signKP2, signDN2, signKP2, signDN2, _sigAlg);
            testerKP1 = KeyPairAndCertificateUtil.makeGOSTELDHKeyPair();
            testerCert1 = KeyPairAndCertificateUtil.makeCertificate(testerKP1, testerDN1, testerKP1, testerDN1, _sigAlg);
            testerKP2 = KeyPairAndCertificateUtil.makeGOST3410ELKeyPair();
            testerCert2 = KeyPairAndCertificateUtil.makeCertificate(testerKP2, testerDN2, testerKP2, testerDN2, _sigAlg);

            ArrayList certList = new ArrayList();

            CMSSignedDataGenerator gen = new CMSSignedDataGenerator();

            gen.addSigner(signKP1.getPrivate(), signCert1, CMSSignedDataGenerator.DIGEST_GOST3411);
            certList.add(signCert1);
            gen.addSigner(signKP2.getPrivate(), signCert2, CMSSignedDataGenerator.DIGEST_GOST3411);
            certList.add(signCert2);

            CertStore certs = CertStore.getInstance("Collection",
                    new CollectionCertStoreParameters(certList), prov);
            gen.addCertificatesAndCRLs(certs);

            CMSSignedData s = gen.generate(msg, true, prov);

            /*
             *      
             */

            //  
            ArrayList SignerList = new ArrayList();
            SignerList.add(signKP1);
            SignerList.add(signCert1);
            SignerList.add(testerKP1);
            SignerList.add(testerCert1);
            SignerList.add(testerKP2);
            SignerList.add(testerCert2);
            //   
            SignerInformationStore sis = s.getSignerInfos();
            int si1 = sis.size();
            if (si1 > 0) {
                Collection origSigners = sis.getSigners();
                SignerInformation signer = (SignerInformation) origSigners.toArray()[si1-1];
                //     
                // false -    
                s=AddCounterSigners(s,signer,SignerList,false);
            }

            ByteArrayInputStream bIn = new ByteArrayInputStream(s.getEncoded());
            ASN1InputStream aIn = new ASN1InputStream(bIn);

            /*
             *       sig.
             */
            byte[] ec = s.getEncoded();
            //ec = Base64.encode(ec);
            DataOutputStream out = new DataOutputStream(new BufferedOutputStream(new FileOutputStream("test.sig")));
            for (int i = 0; i != ec.length; i++) {
                out.writeByte(ec[i]);
            }
            out.close();

            s = new CMSSignedData(ContentInfo.getInstance(aIn.readObject()));

            certs = s.getCertificatesAndCRLs("Collection", prov);

            SignerInformationStore signers = s.getSignerInfos();
            Collection c = signers.getSigners();
            Iterator it = c.iterator();

            while (it.hasNext()) {
                SignerInformation signer = (SignerInformation) it.next();
                Collection certCollection = certs.getCertificates(signer.getSID());

                Iterator certIt = certCollection.iterator();
                X509Certificate cert = (X509Certificate) certIt.next();

                log("Signature verification status = " + signer.verify(cert, prov));
                assertEquals(true, signer.verify(cert, prov));
            }

            // Next encode

            CMSEnvelopedDataGenerator edGen = new CMSEnvelopedDataGenerator();
            // 
            edGen.addKeyTransRecipient(signCert1);
            edGen.addKeyTransRecipient(signCert2);
            edGen.addKeyTransRecipient(testerCert1);
            // testerCert2     :  
            //edGen.addKeyTransRecipient(testerCert2);

            /*
             * 
             */
            byte[] data = getBytesFromFile("test.sig");
            CMSEnvelopedData ed = edGen.generate(
                    new CMSProcessableByteArray(data),
                    "1.2.643.2.2.21",
                    prov);

            //      
            //byte[] ec = ((EnvelopedData)ed.getcontentInfo().getContent()).
            //        getEncryptedContentInfo().getGOSTEncryptedContent();
            ec = ((EnvelopedData)ed.getContentInfo().getContent()).
                    getEncryptedContentInfo().getEncryptedContent().getOctets();
            ed=null;
            //      p7m.
            /*
             */
            out = new DataOutputStream(
                    new BufferedOutputStream(
                        new FileOutputStream("test.sig.p7m")
                        )
                    );
            //for (int i = 0; i < ec.length; i++)  out.writeByte(ec[i]);
            out.write(ec);out.flush();
            out.close();

            CMSEnvelopedData envData = new CMSEnvelopedData(new ByteArrayInputStream(ec));
            ec = envData.getEncoded();
            //  
            //  
            RecipientInformationStore  recipients = envData.getRecipientInfos();
            Collection  cc = recipients.getRecipients();
            it = cc.iterator();

            while (it.hasNext())
            {
                //           
                //    ,      .
                //        .
                RecipientInformation   recipient = (RecipientInformation)it.next();
                //  
                RecipientId rid = recipient.getRID();
                //      
                Key sk = RecipientKeyInStore(rid);
                byte[] recData = null;
                if (sk == null) {
                } else {
                    if (sk.getClass().getCanonicalName().contains("digt.trusted")) {
                        recData = recipient.getGOSTContent(sk, prov,
                                new DataInputStream(new ByteArrayInputStream(ec)));
                    } else {
                        recData = recipient.getContent(sk, prov);
                    }
                }
                //,       
                assertEquals(true, Arrays.equals(data, recData));
            }
        } catch (Exception ex) {
            log(ex);
            fail();
        }
    }
}
