/*
* Copyright(C) 1999-2008  << >>
*
*    , 
*    << >>.
*
*        ,
* ,    ,
*     ,
* ,     
*     
*     << >>.
*/

package com.digt.trusted.cms.test.bc;

import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.DataOutputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStreamReader;
import java.security.InvalidAlgorithmParameterException;
import java.security.KeyPair;
import java.security.NoSuchAlgorithmException;
import java.security.NoSuchProviderException;
import java.security.Provider;
import java.security.Security;
import java.security.cert.CertStore;
import java.security.cert.CertStoreException;
import java.security.cert.CertificateExpiredException;
import java.security.cert.CertificateNotYetValidException;
import java.security.cert.CollectionCertStoreParameters;
import java.security.cert.X509Certificate;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Iterator;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1InputStream;
import org.bouncycastle.asn1.cms.AttributeTable;
import org.bouncycastle.asn1.cms.ContentInfo;
import org.bouncycastle.asn1.pkcs.PKCSObjectIdentifiers;
import org.bouncycastle.cms.CMSException;
import org.bouncycastle.cms.CMSProcessable;
import org.bouncycastle.cms.CMSProcessableByteArray;
import org.bouncycastle.cms.CMSSignedData;
import org.bouncycastle.cms.CMSSignedDataGenerator;
import org.bouncycastle.cms.SignerId;
import org.bouncycastle.cms.SignerInformation;
import org.bouncycastle.cms.SignerInformationStore;
import org.bouncycastle.util.encoders.Base64;

import com.digt.trusted.jce.test.KeyPairAndCertificateUtil;

public class SignedDataTest_bc
        extends TestCase
{

     /*
    *
    *  VARIABLES
    *
    */

    boolean DEBUG = true;
    String          signDN1;
    KeyPair         signKP1;
    X509Certificate signCert1;

    String          signDN2;
    KeyPair         signKP2;
    X509Certificate signCert2;

    String          testerDN1;
    KeyPair         testerKP1;
    X509Certificate testerCert1;

    String          testerDN2;
    KeyPair         testerKP2;
    X509Certificate testerCert2;

    /*
    *
    *  INFRASTRUCTURE
    *
    */

    public SignedDataTest_bc(String name) {
        super(name);
    }

    public static void main(String args[]) {

        junit.textui.TestRunner.run(SignedDataTest_bc.class);
    }

    public static Test suite() {
        return new TestSuite(SignedDataTest_bc.class);
    }

    void log(Exception _ex) {
        if(DEBUG) {
            _ex.printStackTrace();
        }
    }

    void log(String _msg) {
        if(DEBUG) {
            System.out.println(_msg);
        }
    }

    public void setUp()
    {
        signDN1 = "CN=Developer1, E=info@digt.ru, O=DIGT, C=RU";
        signDN2 = "CN=Developer2, E=info@digt.ru, O=DIGT, C=RU";
        testerDN1 = "CN=Tester1, E=info@digt.ru, O=DIGT, C=RU";
        testerDN2 = "CN=Tester2, E=info@digt.ru, O=DIGT, C=RU";
    }

    public void tearDown() {

    }

    private byte[] getBytesFromFile(String pFile) {
        int sl = 0,
                count = 0;
        byte[] b = new byte[0];
        try {
            FileInputStream inFile = new FileInputStream(pFile);
            // ,     
            int bytesAvailable = 0;
            while ((bytesAvailable = inFile.available()) != 0) {
                //   
                b = Arrays.copyOf(b, bytesAvailable + sl);
                count = inFile.read(b, sl, bytesAvailable);
                sl += count;
            }
            inFile.close();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        return b;
    }

    private String getStringFromFile(String inFile) {
        String s = "";
        try {
            BufferedReader dataIn = new BufferedReader(
                    new InputStreamReader(new FileInputStream(inFile)));

            String buf = null;
            while ((buf = dataIn.readLine()) != null) {
                s += buf;
            }
            dataIn.close();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        return s;
    }

    /*
    *  TESTS
    */

    //      "GOST3411WithGOST3410"
//    public void testGOST3411WithGOST3410()
//    {
//        try
//        {
//
//            //      
//            String   _sigAlg   = "GOST3411WithGOST3410";
//            signKP   = KeyPairAndCertificateUtil.makeGOST3410KeyPair();
//            signCert = KeyPairAndCertificateUtil.makeCertificate(signKP, signDN, signKP, signDN, _sigAlg);
//
//            //  
//            // 
//            CMSProcessable      msg = new CMSProcessableByteArray("Test Data".getBytes());
//            // CMS 
//            CMSSignedDataGenerator gen = new CMSSignedDataGenerator();
//            // 
//            gen.addSigner(signKP.getPrivate(), signCert, CMSSignedDataGenerator.DIGEST_GOST3411);
//
//            //    CRL    ,        CRL ,       ,    .
//            ArrayList           certList = new ArrayList();
//            certList.add(signCert);
//            CertStore           certs = CertStore.getInstance("Collection",
//                    new CollectionCertStoreParameters(certList), "DIGT");
//            gen.addCertificatesAndCRLs(certs);
//
//            //
//            CMSSignedData s = gen.generate(msg, true, "DIGT");
//            //  
//            ByteArrayInputStream bIn = new ByteArrayInputStream(s.getEncoded());
//            //    .
//            /*DataOutputStream out_msg = new DataOutputStream( new BufferedOutputStream(new FileOutputStream("c:\\signed_gost.p7s.")));
//            for (int i = 0; i != bIn.length; i++) out_msg.writeByte(bIn[i]);
//            out_msg.close();*/
//
//            //  
//            // ASN   
//            ASN1InputStream      aIn = new ASN1InputStream(bIn);
//
//            // CMS   ASN 
//            s = new CMSSignedData(ContentInfo.getInstance(aIn.readObject()));
//
//            //     ,           
//            certs = s.getCertificatesAndCRLs("Collection", "DIGT");
//
//            //    
//            SignerInformationStore  signers = s.getSignerInfos();
//            Collection              c = signers.getSigners();
//            Iterator                it = c.iterator();
//            //   
//            while (it.hasNext())
//            {
//                //    
//                SignerInformation   signer = (SignerInformation)it.next();
//                //     
//                Collection          certCollection = certs.getCertificates(signer.getSID());
//                Iterator        certIt = certCollection.iterator();
//                X509Certificate cert = (X509Certificate)certIt.next();
//                // .
//                log("Signature verification status = " + signer.verify(cert, "DIGT"));
//                assertEquals(true, signer.verify(cert, "DIGT"));
//            }
//        }
//        catch(Exception ex)
//        {
//            log(ex);
//            fail();
//        }
//    }

    private CMSSignedData AddCounterSigners(
            CMSSignedData s,
            SignerInformation signer,
            ArrayList SignersList,
            boolean allin1) {

        if (SignersList.isEmpty() || signer == null) {
            return s;
        }

        String prov = "DIGT";
        ArrayList csNew = null;
        AttributeTable signer_at = null;
        SignerInformationStore sis = null;
        SignerInformation signer1 = null;
        SignerInformation origSigner = null;

        SignerId orig_SID = signer.getSID();
        try {
            //        .
            ArrayList certList = new ArrayList();
            CertStore s_orig = s.getCertificatesAndCRLs("Collection", prov);
            //    
            certList.addAll(s_orig.getCRLs(null));
            //  
            certList.addAll(s_orig.getCertificates(null));
            //  CMS-
            CMSSignedDataGenerator gen = new CMSSignedDataGenerator();
            //  
            for (int i = 0; i < ((allin1)?SignersList.size() / 2:1); i++) {
                gen.addSigner(((KeyPair) SignersList.get(2 * i)).getPrivate(),
                        (X509Certificate) SignersList.get(2 * i + 1),
                        CMSSignedDataGenerator.DIGEST_GOST3411);
                certList.add((X509Certificate) SignersList.get(2 * i + 1));
            }
            //      
            CertStore certs = CertStore.getInstance("Collection", new CollectionCertStoreParameters(certList), prov);
            //gen.addCertificatesAndCRLs(certs);

            //         
            s = CMSSignedData.replaceCertificatesAndCRLs(s, certs);
            //  
            sis = s.getSignerInfos();
            origSigner = sis.get(orig_SID);
            if (origSigner == null) {
                return s; //  
            }
            SignerInformationStore cs1 = gen.generateCounterSigners(origSigner, prov);
            signer1 = SignerInformation.addCounterSigners(origSigner, cs1);
            SignerInformationStore cs = signer1.getCounterSignatures();
            //  
            Collection csSigners = cs.getSigners();
            Iterator it = csSigners.iterator();
            while (it.hasNext()) {
                SignerInformation cSigner = (SignerInformation) it.next();
                Collection certCollection = certs.getCertificates(cSigner.getSID());
                Iterator certIt = certCollection.iterator();
                X509Certificate cert = (X509Certificate) certIt.next();
                assertNull(cSigner.getSignedAttributes().get(PKCSObjectIdentifiers.pkcs_9_at_contentType));
                assertEquals(true, cSigner.verify(cert, prov));
            }
        } catch (NoSuchAlgorithmException ex) {
            ex.printStackTrace();
        } catch (NoSuchProviderException ex) {
            ex.printStackTrace();
        } catch (CertificateExpiredException ex) {
            ex.printStackTrace();
        } catch (CertificateNotYetValidException ex) {
            ex.printStackTrace();
        } catch (CMSException ex) {
            ex.printStackTrace();
        } catch (InvalidAlgorithmParameterException ex) {
            ex.printStackTrace();
        } catch (CertStoreException ex) {
            ex.printStackTrace();
        }
        /*
         *      ,
         *   .
         * (   ?!)
         *
         */
        signer_at = signer1.getUnsignedAttributes();
        /*
        AttributeTable origSigner_at = origSigner.getUnsignedAttributes();
        if (origSigner_at != null) {
            ASN1EncodableVector origSigner_atv = origSigner_at.toASN1EncodableVector();
            ASN1EncodableVector signer_atv = signer_at.toASN1EncodableVector();
            for (int i = 0; i < signer_atv.size(); i++) {
                origSigner_atv.add(signer_atv.get(i));
            }
            signer_at = new AttributeTable(origSigner_atv);
        }
         */
        Iterator it = sis.getSigners().iterator();
        //      .
        csNew = new ArrayList();
        while (it.hasNext()) {
            SignerInformation ss = (SignerInformation) it.next();
            if (orig_SID.equals(ss.getSID())) {
                ss = SignerInformation.replaceUnsignedAttributes(signer, signer_at);
            }
            csNew.add(ss);
        }
        /*
         *         .
         */
        SignerInformationStore sis_new = new SignerInformationStore(csNew);
        s = CMSSignedData.replaceSigners(s, sis_new);
        //   
        if (allin1) {
            return s;
        } else {
            SignersList.remove(1);
            SignersList.remove(0);
            return AddCounterSigners(s,signer,SignersList,allin1);
        }
    }

    /*
     *       "GOST3411WithGOST3410EL"
     *    ,     
     */

    public void testGOST3411WithGOST3410EL() {
        try {

            log("Start testGOST3411WithGOST3410EL()...");
            String prov = "DIGT";
            String _sigAlg = "GOST3411WithGOST3410EL";

            CMSProcessable msg = new CMSProcessableByteArray("Test Data".getBytes());

            signKP1 = KeyPairAndCertificateUtil.makeGOST3410ELKeyPair();
            signCert1 = KeyPairAndCertificateUtil.makeCertificate(signKP1, signDN1, signKP1, signDN1, _sigAlg);
            signKP2 = KeyPairAndCertificateUtil.makeGOST3410ELKeyPair();
            signCert2 = KeyPairAndCertificateUtil.makeCertificate(signKP2, signDN2, signKP2, signDN2, _sigAlg);
            testerKP1 = KeyPairAndCertificateUtil.makeGOST3410ELKeyPair();
            testerCert1 = KeyPairAndCertificateUtil.makeCertificate(testerKP1, testerDN1, testerKP1, testerDN1, _sigAlg);
            testerKP2 = KeyPairAndCertificateUtil.makeGOST3410ELKeyPair();
            testerCert2 = KeyPairAndCertificateUtil.makeCertificate(testerKP2, testerDN2, testerKP2, testerDN2, _sigAlg);

            ArrayList certList = new ArrayList();

            CMSSignedDataGenerator gen = new CMSSignedDataGenerator();

            gen.addSigner(signKP1.getPrivate(), signCert1, CMSSignedDataGenerator.DIGEST_GOST3411);
            certList.add(signCert1);
            gen.addSigner(signKP2.getPrivate(), signCert2, CMSSignedDataGenerator.DIGEST_GOST3411);
            certList.add(signCert2);

            CertStore certs = CertStore.getInstance("Collection",
                    new CollectionCertStoreParameters(certList), prov);
            gen.addCertificatesAndCRLs(certs);

            CMSSignedData s = gen.generate(msg, true, prov);

            /*
             *      
             */

            //  
            ArrayList SignerList = new ArrayList();
            SignerList.add(signKP1);
            SignerList.add(signCert1);
            SignerList.add(testerKP1);
            SignerList.add(testerCert1);
            SignerList.add(testerKP2);
            SignerList.add(testerCert2);
            //   
            SignerInformationStore sis = s.getSignerInfos();
            int si1 = sis.size();
            if (si1 > 0) {
                Collection origSigners = sis.getSigners();
                SignerInformation signer = (SignerInformation) origSigners.toArray()[si1-1];
                //     
                // false -    
                s=AddCounterSigners(s,signer,SignerList,false);
            }

            ByteArrayInputStream bIn = new ByteArrayInputStream(s.getEncoded());
            ASN1InputStream aIn = new ASN1InputStream(bIn);

            /*
             *       sig.
             */
            byte[] ec = s.getEncoded();
            //ec = Base64.encode(ec);
            DataOutputStream out = new DataOutputStream(new BufferedOutputStream(new FileOutputStream("test.sig")));
            for (int i = 0; i != ec.length; i++) {
                out.writeByte(ec[i]);
            }
            out.close();

            s = new CMSSignedData(ContentInfo.getInstance(aIn.readObject()));

            certs = s.getCertificatesAndCRLs("Collection", prov);

            SignerInformationStore signers = s.getSignerInfos();
            Collection c = signers.getSigners();
            Iterator it = c.iterator();

            while (it.hasNext()) {
                SignerInformation signer = (SignerInformation) it.next();
                Collection certCollection = certs.getCertificates(signer.getSID());

                Iterator certIt = certCollection.iterator();
                X509Certificate cert = (X509Certificate) certIt.next();

                log("Signature verification status = " + signer.verify(cert, prov));
                assertEquals(true, signer.verify(cert, prov));
            }
        } catch (Exception ex) {
            log(ex);
            fail();
        }
    }

    public void testPKCS7() {
        log("Start testPKCS7()...");
        String test_data = "1";

//            Security.addProvider(new DIGTProvider());

        byte[] sigBytes;
        byte[] sigData = getBytesFromFile("test.pem");
        if (sigData[0] == 48) {
            //DER-encoding
            sigBytes = sigData;
        } else {
            //Base64-encoding
            sigBytes = Base64.decode(sigData);
        }

        ByteArrayInputStream byteIn = new ByteArrayInputStream(sigBytes);
        ASN1InputStream aIn = new ASN1InputStream(byteIn);

        try {
            CMSSignedData sig = null;
            CMSProcessable data = new CMSProcessableByteArray(test_data.getBytes("UTF-16LE"));
            // CMS   ASN 
            sig = new CMSSignedData(data, ContentInfo.getInstance(aIn.readObject()));

            //     data  
            //sig = new CMSSignedData(ContentInfo.getInstance(aIn.readObject()));

            //    
            SignerInformationStore signers = sig.getSignerInfos();
            Collection c = signers.getSigners();
            Iterator it = c.iterator();

            //   
            while (it.hasNext()) {
                //    
                SignerInformation signer = (SignerInformation) it.next();

                String signOid = signer.getDigestAlgOID() + "with" + signer.getEncryptionAlgOID();
                Provider[] providers = Security.getProviders("Signature." + signOid);
                Provider provider;
                for (int i = 0; i < providers.length; i++) {
                    provider = providers[i];
                    String providerName = provider.getName();
                    System.out.println("SignOID = " + signOid + " providerName = " + providerName);
                    //     ,           
                    CertStore certs = sig.getCertificatesAndCRLs("Collection", providerName);
                    //     
                    Collection certCollection = certs.getCertificates(signer.getSID());
                    Iterator certIt = certCollection.iterator();
                    X509Certificate cert = (X509Certificate) certIt.next();

                    // .
                    boolean result = signer.verify(cert, providerName);
                    log("Signature (test.pem) verification status = " + result);
                    assertTrue(result);
                }
            }

        } catch (Exception ex) {
            ex.printStackTrace();
            fail(ex.getMessage());
        }
    }
}
