/*
* Copyright(C) 1999-2008  << >>
*
*    , 
*    << >>.
*
*        ,
* ,    ,
*     ,
* ,     
*     
*     << >>.
*/

package com.digt.trusted.jce.provider.test;

import java.io.ByteArrayInputStream;
import java.security.*;
import java.security.KeyPair;
import java.security.PublicKey;
import java.security.cert.*;
import java.util.Date;

import com.digt.trusted.jce.provider.DIGTProvider;
import com.digt.trusted.jce.test.KeyPairAndCertificateUtil;
import com.digt.trusted.util.encoders.Base64;

import junit.framework.TestSuite;
import junit.framework.TestCase;

public class CertTest extends TestCase {

    /*
    *
    *  VARIABLES
    *
    */

    public boolean DEBUG = true;

    //
    // 
    //
    byte[] cert1 = Base64.decode("MIICQzCCAfCgAwIBAgIQaYQDKGqmWbpGNWItSd5f0zAKBgYqhQMCAgMFADBlMSAw"
            + "HgYJKoZIhvcNAQkBFhFpbmZvQGNyeXB0b3Byby5ydTELMAkGA1UEBhMCUlUxEzAR"
            + "BgNVBAoTCkNSWVBUTy1QUk8xHzAdBgNVBAMTFlRlc3QgQ2VudGVyIENSWVBUTy1Q"
            + "Uk8wHhcNMDkwNDA3MTIwMjE1WhcNMTQxMDA0MDcwOTQxWjBlMSAwHgYJKoZIhvcN"
            + "AQkBFhFpbmZvQGNyeXB0b3Byby5ydTELMAkGA1UEBhMCUlUxEzARBgNVBAoTCkNS"
            + "WVBUTy1QUk8xHzAdBgNVBAMTFlRlc3QgQ2VudGVyIENSWVBUTy1QUk8wYzAcBgYq"
            + "hQMCAhMwEgYHKoUDAgIjAQYHKoUDAgIeAQNDAARAAuT/0ab2nICa2ux/SnjBzC3T"
            + "5Zbqy+0iMnmyAuLGfDXmdGQbCXcRjGc/D9DoI6Z+bTt/xMQo/SscaAEgoFzYeaN4"
            + "MHYwCwYDVR0PBAQDAgHGMA8GA1UdEwEB/wQFMAMBAf8wHQYDVR0OBBYEFG2PXgXZ"
            + "X6yRF5QelZoFMDg3ehAqMBIGCSsGAQQBgjcVAQQFAgMCAAIwIwYJKwYBBAGCNxUC"
            + "BBYEFHrJxwnbIByWlC/8Rq1tk9BeaRIOMAoGBiqFAwICAwUAA0EAWHPSk7xjIbEO"
            + "c3Lu8XK1G4u7yTsIu0xa8uGlNU+ZxNVSUnAm3a7QqSfptlt9b0T9Jk39oWN0XHTY"
            + "SXMKd3djTQ==");
            
    byte[] cert2012 = Base64.decode("MIIGpDCCBlGgAwIBAgITfAAAAaOFQxa0GuH9gQAAAAABozAKBggqhQMHAQEDAjCC"
            + "AQoxGDAWBgUqhQNkARINMTIzNDU2Nzg5MDEyMzEaMBgGCCqFAwOBAwEBEgwwMDEy"
            + "MzQ1Njc4OTAxLzAtBgNVBAkMJtGD0LsuINCh0YPRidGR0LLRgdC60LjQuSDQstCw"
            + "0Lsg0LQuIDE4MQswCQYDVQQGEwJSVTEZMBcGA1UECAwQ0LMuINCc0L7RgdC60LLQ"
            + "sDEVMBMGA1UEBwwM0JzQvtGB0LrQstCwMSUwIwYDVQQKDBzQntCe0J4gItCa0KDQ"
            + "mNCf0KLQni3Qn9Cg0J4iMTswOQYDVQQDDDLQotC10YHRgtC+0LLRi9C5INCj0KYg"
            + "0J7QntCeICLQmtCg0JjQn9Ci0J4t0J/QoNCeIjAeFw0xNzEwMzAxMjM3NTdaFw0x"
            + "ODEwMzAxMjQ3NTdaMGYxGTAXBgNVBAMMEHdlYi10ZXN0Z29zdDIwMTIxJTAjBgNV"
            + "BAoMHNCe0J7QniAi0JrQoNCY0J/QotCeLdCf0KDQniIxFTATBgNVBAcMDNCc0L7R"
            + "gdC60LLQsDELMAkGA1UEBhMCUlUwZjAfBggqhQMHAQEBATATBgcqhQMCAiQABggq"
            + "hQMHAQECAgNDAARAhnRU9gr/D9HBiMWy0hthlErfxZN3JLA4bw7ixlRYenIVA9Jk"
            + "MJ51mBnaT+oiMO8MStfj2krUAwZrEPFfqqhSh6OCBCkwggQlMBMGA1UdJQQMMAoG"
            + "CCsGAQUFBwMBMB0GA1UdDgQWBBQ+fS3/HFwI951e89VEhSMEIOqJMzAfBgNVHSME"
            + "GDAWgBRYdGzYb/FfGCTlwbez58vX0fdYfTCCAXwGA1UdHwSCAXMwggFvMIIBa6CC"
            + "AWegggFjhoGyaHR0cDovL3Rlc3Rnb3N0MjAxMi5jcnlwdG9wcm8ucnUvQ2VydEVu"
            + "cm9sbC8hMDQyMiEwNDM1ITA0NDEhMDQ0MiEwNDNlITA0MzIhMDQ0YiEwNDM5JTIw"
            + "ITA0MjMhMDQyNiUyMCEwNDFlITA0MWUhMDQxZSUyMCEwMDIyITA0MWEhMDQyMCEw"
            + "NDE4ITA0MWYhMDQyMiEwNDFlLSEwNDFmITA0MjAhMDQxZSEwMDIyLmNybIaBq2h0"
            + "dHA6Ly90ZXN0Z29zdDIwMTIuY3AucnUvQ2VydEVucm9sbC8hMDQyMiEwNDM1ITA0"
            + "NDEhMDQ0MiEwNDNlITA0MzIhMDQ0YiEwNDM5JTIwITA0MjMhMDQyNiUyMCEwNDFl"
            + "ITA0MWUhMDQxZSUyMCEwMDIyITA0MWEhMDQyMCEwNDE4ITA0MWYhMDQyMiEwNDFl"
            + "LSEwNDFmITA0MjAhMDQxZSEwMDIyLmNybDCCAhIGCCsGAQUFBwEBBIICBDCCAgAw"
            + "RAYIKwYBBQUHMAKGOGh0dHA6Ly90ZXN0Z29zdDIwMTIuY3J5cHRvcHJvLnJ1L0Nl"
            + "cnRFbnJvbGwvcm9vdDIwMTMuY3J0MD0GCCsGAQUFBzAChjFodHRwOi8vdGVzdGdv"
            + "c3QyMDEyLmNwLnJ1L0NlcnRFbnJvbGwvcm9vdDIwMTMuY3J0MDgGCCsGAQUFBzAB"
            + "hixodHRwOi8vdGVzdGdvc3QyMDEyLmNwLnJ1L29jc3AyMDEyZy9vY3NwLnNyZjA/"
            + "BggrBgEFBQcwAYYzaHR0cDovL3Rlc3Rnb3N0MjAxMi5jcnlwdG9wcm8ucnUvb2Nz"
            + "cDIwMTJnL29jc3Auc3JmMEEGCCsGAQUFBzABhjVodHRwOi8vdGVzdGdvc3QyMDEy"
            + "LmNyeXB0b3Byby5ydS9vY3NwMjAxMmdzdC9vY3NwLnNyZjA6BggrBgEFBQcwAYYu"
            + "aHR0cDovL3Rlc3Rnb3N0MjAxMi5jcC5ydS9vY3NwMjAxMmdzdC9vY3NwLnNyZjBC"
            + "BggrBgEFBQcwAYY2aHR0cDovL3Rlc3Rnb3N0MjAxMi5jcnlwdG9wcm8ucnUvb2Nz"
            + "cDIwMTJnc3QyL29jc3Auc3JmMDsGCCsGAQUFBzABhi9odHRwOi8vdGVzdGdvc3Qy"
            + "MDEyLmNwLnJ1L29jc3AyMDEyZ3N0Mi9vY3NwLnNyZjA4BgNVHREEMTAvghl0ZXN0"
            + "Z29zdDIwMTIuY3J5cHRvcHJvLnJ1ghJ0ZXN0Z29zdDIwMTIuY3AucnUwCgYIKoUD"
            + "BwEBAwIDQQBu6E6SQzad+tV4TQjeKgT3X4eim9U7XHY2msYfGcWu7Up7Fvt5NixJ"
            + "S9YA3JHNtwizbN5Kk9TAkeI/0SV3HGSw");

    //
    // CRL
    //
    byte[] crl = Base64.decode("MIIBSTCB9wIBATAKBgYqhQMCAgMFADBlMSAwHgYJKoZIhvcNAQkBFhFpbmZvQGNy"
            + "eXB0b3Byby5ydTELMAkGA1UEBhMCUlUxEzARBgNVBAoTCkNSWVBUTy1QUk8xHzAd"
            + "BgNVBAMTFlRlc3QgQ2VudGVyIENSWVBUTy1QUk8XDTA5MDYzMDEyMDIyOVoXDTA5"
            + "MDcwODAwMjIyOVqgYTBfMB8GA1UdIwQYMBaAFG2PXgXZX6yRF5QelZoFMDg3ehAq"
            + "MBIGCSsGAQQBgjcVAQQFAgMCAAIwCgYDVR0UBAMCAS0wHAYJKwYBBAGCNxUEBA8X"
            + "DTA5MDcwNzEyMTIyOVowCgYGKoUDAgIDBQADQQDSIVkmlF+YtIqdbCpwTiNcKgds"
            + "H6FmkXecT7RMqO99xqKD24FKJUcScLiUCVsYItCTKLoIhtNerhDuv7bjEdTB");

    /*
    *
    *  INFRASTRUCTURE
    *
    */

    public CertTest(String name) {
        super(name);
    }

    public static void main(String args[]) {
        junit.textui.TestRunner.run(CertTest.class);
    }

    public static junit.framework.Test suite() {
        return new TestSuite(CertTest.class);
    }

    public void log(Exception _ex) {
        if (DEBUG) {
            _ex.printStackTrace();
        }
    }

    public void log(String _msg) {
        if (DEBUG) {
            System.out.println(_msg);
        }
    }

    public void setUp() {
        Security.addProvider(new DIGTProvider());
    }


    public void tearDown() {

    }

    /*
    *
    *  TESTS
    *
    */

    public void testCertificates() {
        ByteArrayInputStream _in;
        try {
            _in = new ByteArrayInputStream(cert1);
            CertificateFactory _cf = CertificateFactory.getInstance("X.509", "DIGT");
            X509Certificate _cert = (X509Certificate) _cf.generateCertificate(_in);
            PublicKey _subPubKey = _cert.getPublicKey();
            log(_cert.toString());
            log(_subPubKey.toString());
            try {
            _cert.checkValidity();
            } catch (CertificateExpiredException ex) {}
        } catch (Exception ex) {
            log(ex);
            fail();
        }
    }
	
	public void testCertificates2012() {
        ByteArrayInputStream _in;
        try {
            _in = new ByteArrayInputStream(cert2012);
            CertificateFactory _cf = CertificateFactory.getInstance("X.509", "DIGT");
            X509Certificate _cert = (X509Certificate) _cf.generateCertificate(_in);
            PublicKey _subPubKey = _cert.getPublicKey();
            log(_cert.toString());
            log(_subPubKey.toString());
            try {
            _cert.checkValidity();
            } catch (CertificateExpiredException ex) {}
        } catch (Exception ex) {
            log(ex);
            fail();
        }
    }

    /**
     *
     */
    public void testSelfSignedCertificateCreation() {
        try {

            String _dn = "CN=Developer, E=info@digt.ru, O=DIGT, C=RU";
            KeyPair _kp = KeyPairAndCertificateUtil.makeGOST3410ELKeyPair();
            X509Certificate _cert = KeyPairAndCertificateUtil.makeCertificate(_kp, _dn, _kp, _dn, "GOST3411WithGOST3410EL");

            ByteArrayInputStream _in = new ByteArrayInputStream(_cert.getEncoded());
            CertificateFactory _cf = CertificateFactory.getInstance("X.509", "DIGT");
            _cert = (X509Certificate) _cf.generateCertificate(_in);

            _cert.checkValidity();
            _cert.checkValidity(new Date());
            log(_cert.toString());
        } catch (Exception ex) {
            log(ex);
            fail();
        }

    }

    /**
     *
     */
    public void testCertificateCreation() {
        try {

            String _subDN = "CN=Developer, E=info@digt.ru, O=DIGT, C=RU";
            String _issDN = "CN=CA, E=info@digt.ru, O=DIGT, C=RU";
            KeyPair _subKP = KeyPairAndCertificateUtil.makeGOST3410ELKeyPair();
            KeyPair _issKP = KeyPairAndCertificateUtil.makeGOST3410ELKeyPair();

            X509Certificate _caCert = KeyPairAndCertificateUtil.makeCACertificate(_issKP, _issDN, _issKP, _issDN, "GOST3411WithGOST3410EL");
            X509Certificate _devCert = KeyPairAndCertificateUtil.makeCertificate(_subKP, _subDN, _issKP, _issDN, "GOST3411WithGOST3410EL");

            ByteArrayInputStream _in = new ByteArrayInputStream(_caCert.getEncoded());
            CertificateFactory _cf = CertificateFactory.getInstance("X.509", "DIGT");
            _caCert = (X509Certificate) _cf.generateCertificate(_in);
            _caCert.checkValidity();
            _caCert.checkValidity(new Date());
            _caCert.verify(_issKP.getPublic(), "DIGT");
            log(_caCert.toString());

            _in = new ByteArrayInputStream(_devCert.getEncoded());
            _devCert = (X509Certificate) _cf.generateCertificate(_in);
            _devCert.checkValidity();
            _devCert.checkValidity(new Date());
            _devCert.verify(_issKP.getPublic(), "DIGT");
            log(_devCert.toString());

        } catch (Exception ex) {
            log(ex);
            fail();
        }

    }

    public void testCRL() {
        ByteArrayInputStream _in;

        try {
            _in = new ByteArrayInputStream(crl);
            CertificateFactory _cf = CertificateFactory.getInstance("X.509", "DIGT");
            X509CRL _crl = (X509CRL) _cf.generateCRL(_in);
            log(_crl.toString());
        } catch (Exception ex) {
            log(ex);
            fail();
        }
    }
}
