/*
* Copyright(C) 1999-2008  << >>
*
*    , 
*    << >>.
*
*        ,
* ,    ,
*     ,
* ,     
*     
*     << >>.
*/

package com.digt.trusted.jce.provider.test;

import com.digt.trusted.jce.provider.DIGTProvider;
import com.digt.trusted.jce.test.KeyPairAndCertificateUtil;

import java.security.*;

import junit.framework.TestCase;
import junit.framework.TestSuite;

public class GOST3410Test
        extends TestCase
{
    /*
    *
    *  VARIABLES
    *
    */
    boolean DEBUG = true;

    /*
    *
    *  INFRASTRUCTURE
    *
    */

    public GOST3410Test(String name) {
        super(name);
    }

    public static void main(String args[]) {
        //junit.textui.TestRunner.run(GOST3410Test.class);
    }

    public static junit.framework.Test suite() {
        return new TestSuite(GOST3410Test.class);
    }

    public void log(Exception _ex) {
        if (DEBUG) {
            _ex.printStackTrace();
        }
    }

    public void log(String _msg) {
        if (DEBUG) {
            System.out.println(_msg);
        }
    }

    public void setUp() {
    }

    public void tearDown() {
    }

    /*
    *
    *  TESTS
    *
    */
//    public void testGOST3410() {
//        try {
//            Security.addProvider(new DIGTProvider());
//
//            boolean status = false;
//            String data = "Test Data";
//            Signature sig = Signature.getInstance("GOST3410", "DIGT");
//            KeyPair signKP = KeyPairAndCertificateUtil.makeGOST3410KeyPair();
//            PrivateKey privKey = signKP.getPrivate();
//            PublicKey pubKey = signKP.getPublic();
//
//            sig.initSign(privKey);
//            sig.update(data.getBytes());
//            byte[] sigBytes = sig.sign();
//
//            sig = Signature.getInstance("GOST3410", "DIGT");
//            sig.initVerify(pubKey);
//            sig.update(data.getBytes());
//            status = sig.verify(sigBytes);
//
//            log("Signature verification status = " + status);
//            assertEquals(true, status);
//
//            sig = Signature.getInstance("GOST3410", "DIGT");
//            sig.initSign(privKey);
//            sig.update(data.getBytes());
//            sigBytes = sig.sign();
//
//            sig = Signature.getInstance("GOST3410", "DIGT");
//            sig.initVerify(pubKey);
//            sig.update(data.getBytes());
//
//            status = sig.verify(sigBytes);
//            log("Signature verification status = " + status);
//            assertEquals(true, status);
//
//        } catch (Exception ex) {
//            log(ex);
//            fail();
//
//        }
//    }

   public void testGOSTECDH() {
        try {
            boolean status = false;
            String data = "Test Data";
            Signature sig = Signature.getInstance("GOST3410", "DIGT");
            KeyPair signKP = KeyPairAndCertificateUtil.makeGOSTDHKeyPair();
            PrivateKey privKey = signKP.getPrivate();
            PublicKey pubKey = signKP.getPublic();

            sig.initSign(privKey);
            sig.update(data.getBytes());
            byte[] sigBytes = sig.sign();

            sig = Signature.getInstance("GOST3410", "DIGT");
            sig.initVerify(pubKey);
            sig.update(data.getBytes());
            status = sig.verify(sigBytes);

            log("Signature verification status = " + status);
            assertEquals(true, status);

            sig = Signature.getInstance("GOST3410", "DIGT");
            sig.initSign(privKey);
            sig.update(data.getBytes());
            sigBytes = sig.sign();

            sig = Signature.getInstance("GOST3410", "DIGT");
            sig.initVerify(pubKey);
            sig.update(data.getBytes());
            status = sig.verify(sigBytes);

            log("Signature verification status = " + status);
            assertEquals(true, status);

        } catch (Exception ex) {
            log(ex);
            fail();
        }
    }
}
