/*
* Copyright(C) 1999-2015  << >>
*
*    , 
*    << >>.
*
*        ,
* ,    ,
*     ,
* ,     
*     
*     << >>.
*/

package com.digt.trusted.jce.provider.test;

import com.digt.trusted.jce.provider.DIGTProvider;
import com.digt.trusted.jce.test.KeyPairAndCertificateUtil;
import com.digt.trusted.util.encoders.Hex;

import java.security.*;

import junit.framework.TestCase;
import junit.framework.TestSuite;

public class GOST3411Test
        extends TestCase
{
    /*
    *
    *  VARIABLES
    *
    */
    boolean DEBUG = true;

    static String[] hashesTests =
            {
                "616263", // data is "abc" in hex format
                "B285056DBF18D7392D7677369524DD14747459ED8143997E163B2986F92FD42C" // hash
            };

    /*
    *
    *  INFRASTRUCTURE
    *
    */

    public GOST3411Test(String name) {
        super(name);
    }

    public static void main(String args[]) {
        junit.textui.TestRunner.run(GOST3411Test.class);
    }

    public static junit.framework.Test suite() {
        return new TestSuite(GOST3411Test.class);
    }

    public void log(Exception _ex) {
        if (DEBUG) {
            _ex.printStackTrace();
        }
    }

    public void log(String _msg) {
        if (DEBUG) {
            System.out.println(_msg);
        }
    }

    public void setUp() {
        Security.addProvider(new DIGTProvider());
    }

    public void tearDown() {
    }

    /*
    *
    *  TESTS
    *
    */

   public void testGOST3411_94() {
        try {
            MessageDigest md = MessageDigest.getInstance("GOST3411");

            md.update(Hex.decode(hashesTests[0]));
            byte[] digest = md.digest();

            log("GOST R 34.11-94 test - expected " + hashesTests[1] + " got " + new String(Hex.encode(digest)));
            assertEquals(true, MessageDigest.isEqual(digest, Hex.decode(hashesTests[1])));
        } catch (Exception ex) {
            log(ex);
            fail();
        }
    }
}
