/*
 * Copyright(C) 1999-2008  << >>
 *
 *    , 
 *    << >>.
 *
 *        ,
 * ,    ,
 *     ,
 * ,     
 *     
 *     << >>.
 */
package com.digt.trusted.xmlsig.test;

import com.digt.trusted.jce.provider.DIGTProvider;
import com.digt.trusted.xmlsig.Consts;
import java.io.File;
import org.apache.xml.security.keys.KeyInfo;
import org.apache.xml.security.signature.XMLSignature;
import org.apache.xml.security.utils.Constants;
import org.apache.xpath.XPathAPI;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import java.security.PublicKey;
import java.security.Security;
import java.security.cert.X509Certificate;

/**
 *
 *    XML-
 *     "XmlTwoDSig.xml"
 *     
 */

public class Xml2SigDocVerify {

    private Xml2SigDocVerify() {
    }

    /**
     *
     * @param args   XML-,   .
     */
    public static void main(String[] args) {
        try {
            Security.addProvider(new DIGTProvider());

            // xml 
            String signedDoc = "XmlTwoDSig.xml";
            //signedDoc = "XmlTwoDSig_jcp.xml";

            /*
             *      
             * 
             *
             *    MSXML 5.0,  JCP (   Straight)
            init(Consts.CONFIG);
             *   (   Straight)
            init("resource/tj.xml");
             */
            init(Consts.CONFIG);

            //      
            if (args.length == 0) {
                args = new String[1];
                args[0] = signedDoc;
            }
            for (int i = 0; i < args.length; i++) {
                signedDoc = args[i];
                if ((new File(signedDoc)).exists()) {
                    System.out.println("Verify sign of XML-file: " + signedDoc + " ... ");
                    twoSignDocVer(signedDoc);
                }
            }

        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     *   XML security   
     * @param config   XML security
     * @throws Exception
     */
    static void init(String config) throws Exception {
        System.setProperty(Consts.PROPERTY_NAME, config);
        org.apache.xml.security.Init.init();
    }

    /**
     * 
     * @param signTwo
     * @throws Exception
     */
    static void twoSignDocVer(String signTwo) throws Exception {
        //    XML-
        DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();

        //  ,         XML-
        dbf.setIgnoringElementContentWhitespace(true);

        //  ,    CDATA      XML-
        dbf.setCoalescing(true);

        //  ,       XML-
        dbf.setNamespaceAware(true);

        //         
        DocumentBuilder documentBuilder = dbf.newDocumentBuilder();

        /*   XML-   */
        Document doc = documentBuilder.parse(signTwo);

        /*    <ds:Signature>  XML- */

        //        Signature
        Element nscontext = doc.createElementNS(null, "namespaceContext");
        nscontext.setAttributeNS("http://www.w3.org/2000/xmlns/",
                "xmlns:" + "ds".trim(), Constants.SignatureSpecNS);

        //    
        Element[] sigElement = new Element[2];

        //          <ds:Signature>
        sigElement[0] = (Element) XPathAPI.selectSingleNode(doc,
                "//ds:Signature[@Id='FirstSignature']", nscontext);

        //          <ds:Signature>
        sigElement[1] = (Element) XPathAPI.selectSingleNode(doc,
                "//ds:Signature[@Id='SecondSignature']", nscontext);

        /*    XML-       ,  
        XML- */

        //     
        XMLSignature[] signature = new XMLSignature[2];

        //     
        signature[0] = new XMLSignature(sigElement[0], "");

        //     
        signature[1] = new XMLSignature(sigElement[1], "");

        //     
        for (int i = 0; i < 2; i++) {

            //   <ds:KeyInfo>    
            KeyInfo ki = signature[i].getKeyInfo();

            //        
            X509Certificate certKey = ki.getX509Certificate();

            //   ,   
            //    
            if (certKey != null) {
                System.out.println("The XML signature " + (i + 1) + " is "
                        + (signature[i].checkSignatureValue(certKey) ? "valid (good)" : "invalid (bad)"));
            } //        
            else {
                //         
                PublicKey pk = ki.getPublicKey();

                //    ,      
                if (pk != null) {
                    System.out.println("The XML signature " + (i + 1) + " is "
                            + (signature[i].checkSignatureValue(pk) ? "valid (good)" : "invalid (bad)"));
                } //        
                else {
                    throw new Exception(
                            "There are no information about public key. Verification couldn't be implemented");
                }

            }
        }

    }
}
