/*
* Copyright(C) 1999-2008  << >>
*
*    , 
*    << >>.
*
*        ,
* ,    ,
*     ,
* ,     
*     
*     << >>.
*/

package common.test;

import java.io.*;
import java.security.Security;
import javax.net.ssl.SSLSocketFactory;
import javax.net.ssl.SSLSocket;

public class SSLSocketClient {

    public static void main(String[] args) throws Exception {
    try {

        Security.setProperty("ssl.SocketFactory.provider", "com.digt.trusted.jsse.provider.DigtSocketFactory");

        // Specify path to your client certificate here
        System.setProperty("com.digt.trusted.jsse.certFile", "/certs/TEST2_cryptopro.cer");
        // Specify certificate password here
        //System.setProperty("com.digt.trusted.jsse.keyPasswd", "");

        SSLSocketFactory factory = (SSLSocketFactory) SSLSocketFactory.getDefault();
        //SSLSocket socket =  (SSLSocket)factory.createSocket("172.17.2.158", 8443);
        SSLSocket socket =  (SSLSocket)factory.createSocket("localhost", 4444);
        /*
        String [] s = {"CPDH-aGOST-eGOST-dGOST-31","CPDH-aGOST-eGOST-dGOST-81"};
         *
         */
        String [] s = {"CPDH-aGOST-eGOST-dGOST-81"};
        socket.setEnabledCipherSuites(s);

        PrintWriter out = new PrintWriter(
                  new BufferedWriter(
                  new OutputStreamWriter(
                       socket.getOutputStream())));

        out.println("GET / HTTP/1.0");
        out.println();
        out.flush();

        /*
           * Make sure there were no surprises
           */
        if (out.checkError())
        System.out.println(
            "SSLSocketClient:  java.io.PrintWriter error");

        /* read response */
        BufferedReader in = new BufferedReader(
                    new InputStreamReader(
                    socket.getInputStream()));

        String inputLine;
        while ((inputLine = in.readLine()) != null)
        System.out.println(inputLine);

        in.close();
        out.close();
        socket.close();

    } catch (Exception e) {
        e.printStackTrace();
    }
    }
}
