/*
 * Copyright(C) 1999-2008  << >>
 *
 *    , 
 *    << >>.
 *
 *        ,
 * ,    ,
 *     ,
 * ,     
 *     
 *     << >>.
 */
package common.test;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.InetAddress;
import java.security.Principal;
import java.security.cert.X509Certificate;
import java.util.Date;
import javax.net.ssl.SSLContext;
import javax.net.ssl.SSLPeerUnverifiedException;
import javax.net.ssl.SSLServerSocket;
import javax.net.ssl.SSLServerSocketFactory;
import javax.net.ssl.SSLSession;
import javax.net.ssl.SSLSocket;

public class SSLSocketServerTest {

    public static void main(String[] args) {
        System.out.println("Welcome to Server side");
        BufferedReader in = null;
        PrintWriter out = null;

        SSLServerSocket servers = null;
        SSLSocket fromclient = null;

        // create server socket
        System.setProperty("com.digt.trusted.jsse.server.verifyDepth", "1");
        System.setProperty("com.digt.trusted.jsse.server.certFile", "/certs/test1-server.cer");
        System.setProperty("com.digt.trusted.jsse.server.keyPasswd", "1111111");
        SSLContext ssl_cnt;
        try {
            ssl_cnt = SSLContext.getInstance("GostTLS");
            SSLServerSocketFactory factory = ssl_cnt.getServerSocketFactory();
            servers = (SSLServerSocket) factory.createServerSocket(4444);
        } catch (Exception ex) {
            System.out.println("Couldn't listen to port 4444");
            System.exit(-1);
        }

        servers.setNeedClientAuth(true);
        //AboutEnabledCipherSuites(servers);
        //servers.setEnabledCipherSuites(new String [] {"CPDH-aGOST-eGOST-dGOST-81","CPDH-aGOST-eGOST-dGOST-31"});
        servers.setEnabledCipherSuites(new String[]{"CPDH-aGOST-eGOST-dGOST-81"});
        AboutEnabledCipherSuites(servers);
        System.out.print("Waiting for a client...");

        int i = 1;
        while (i == 1) {
            try {
                fromclient = (SSLSocket) servers.accept();
            } catch (IOException ex) {
                continue;
            }
            System.out.println("Client connected 1");

            InputStream isr;
            try {
                isr = fromclient.getInputStream();
            } catch (IOException ex) {
                continue;
            }

            AboutSocket("Client socket : ", fromclient);
            in = new BufferedReader(new InputStreamReader(isr));
            try {
                out = new PrintWriter(fromclient.getOutputStream(), true);
                String input;

                System.out.println("Wait for messages");
                out.println("HTTP/1.0 200 OK");
                out.println("Content-type: text/html");
                out.println("");
                out.println("<html><body>");
                input = in.readLine();
		if (input == null) continue;
                while (input.length()>0) {
                    out.println("S ::: " + input + "<br>");
                    System.out.println(input);
                    input = in.readLine();
                }
                out.println("</body></html>");
                out.close();
                in.close();
                fromclient.close();
            } catch (IOException ex) {
                //ex.printStackTrace();
            }
        }
        try {
            servers.close();
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }

    private static void AboutEnabledCipherSuites(SSLServerSocket ss) {
        String [] st = ss.getEnabledCipherSuites();
        String s = st[0];
        for (int i = 1; i < st.length; i++) {
            s += ":" + st[i];
        }
        System.out.println("EnabledCipherSuites = " + s);
    }

    private static void AboutSocket(String prefix, SSLSocket s) {
        String[] cs = s.getEnabledCipherSuites();
        String[] ep = s.getEnabledProtocols();
        if (cs.length > 0) {
            System.out.println(prefix + " SSLSocket.getEnabledCipherSuites() = " + cs[0]);
        }
        if (ep.length > 0) {
            System.out.println(prefix + " SSLSocket.getEnabledProtocols() = " + ep[0]);
        }
        InetAddress ia = s.getInetAddress();
        System.out.println(prefix + " SSLSocket.getInetAddress().getHostAddress() = " + ia.getHostAddress());
        SSLSession ss = s.getSession();
        About_session(prefix, ss);
    }

    private static void About_session(String prefix, SSLSession ss) {
        System.out.println(prefix + " Session.getCipherSuite() = " + ss.getCipherSuite());
        System.out.println(prefix + " Session.getPeerHost() = " + ss.getPeerHost());
        System.out.println(prefix + " Session.getProtocol() = " + ss.getProtocol());
        System.out.println(prefix + " Session.getId().length = " + ss.getId().length);
        System.out.println(prefix + " Session.getId() = " + ss.getId());
        System.out.println(prefix + " Session.getLastAccessedTime() = " + new Date(ss.getLastAccessedTime()));
        X509Certificate[] lcerts = (X509Certificate[]) ss.getLocalCertificates();
        if (lcerts == null) {
            System.out.println(prefix + " None local certificate");
        } else {
            Principal lp = ss.getLocalPrincipal();
            System.out.println(prefix + " Session.getLocalPrincipal().toString() = " + lp.toString());
        }
        try {
            System.out.println(prefix + " Session.getPeerPrincipal().toString() = " + ss.getPeerPrincipal().toString());
        } catch (SSLPeerUnverifiedException ex) {
            //ex.printStackTrace();
        }
    }
}
