/*
* Copyright(C) 1999-2008  << >>
*
*    , 
*    << >>.
*
*        ,
* ,    ,
*     ,
* ,     
*     
*     << >>.
*/


package common.test;

import com.digt.trusted.util.encoders.Base64;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.InetSocketAddress;
import java.net.Proxy;
import java.net.URL;
import java.security.Security;
import javax.net.ssl.HttpsURLConnection;

/* 
 * This example illustrates using a URL to access resources
 * on a secure site.
 *
 * If you are running inside a firewall, please also set the following
 * Java system properties to the appropriate value:
 *
 *   https.proxyHost = <secure proxy server hostname>
 *   https.proxyPort = <secure proxy server port>
 * 
 */

public class URLReader {

    public static void main(String[] args) throws Exception {
        Security.setProperty("ssl.SocketFactory.provider", "com.digt.trusted.jsse.provider.DigtSocketFactory");

        // Local Url`s - without proxy
        Proxy proxy = Proxy.NO_PROXY;
        // Setup client certificate
        System.setProperty("com.digt.trusted.jsse.certFile", "/certs/TEST2_cryptopro.cer");
        getURL("https://localhost:8443/", proxy);

        // Global Url`s - with proxy
        proxy = new Proxy(Proxy.Type.HTTP, new InetSocketAddress("proxy", 3128));
        System.setProperty("com.digt.trusted.jsse.certFile", "");
        getURL("https://cryptopro.ru", proxy);
    }

    private static void getURL(String sUrl, Proxy proxy) throws Exception  {
        URL url;

        // https
        url = new URL(sUrl);
        HttpsURLConnection uc = (HttpsURLConnection) url.openConnection(proxy);
        if (!proxy.equals(Proxy.NO_PROXY)) {
            String encoded = new String(Base64.encode("username:password".getBytes()));
            uc.setRequestProperty("Https-Proxy-Authorization", "Basic " + encoded);
        }
        System.out.println("https>>>" + sUrl);
        BufferedReader in = new BufferedReader(new InputStreamReader(uc.getInputStream()));
        String inputLine;
        while ((inputLine = in.readLine()) != null) {
            System.out.println(inputLine);
        }
        in.close();
    }
}
