<?
ini_set('display_errors',1);
error_reporting(E_ALL);
?>
<!DOCTYPE HTML>
<html>
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=windows-1251">
	<title>Signature test (using of PHP-Java-Bridge, Trusted Java and CryptoPro CSP on the server side)</title>

<script type="text/javascript">
<!--
var DT_PLAIN_DATA = 0;
var DT_SIGNED_DATA = 2;
var BASE64_TYPE = 0;
var SIGN_WIZARD_TYPE = 1;
var SILENT_LEVEL_REQUIRED = 3;

function SignText(text)
{
	var retStr = "";

	try
	{
		//if (text == "")
		//	throw exception

		var isDetachedSign = true; // generate detached (true) or attached (false) signature

		var oCertificate = new ActiveXObject("DigtCrypto.Certificate");
		var oPKCS7Message = new ActiveXObject("DigtCrypto.PKCS7Message");

		var oProfile = new ActiveXObject("DigtCrypto.Profile");
		oProfile.SilentLevel = SILENT_LEVEL_REQUIRED;
		oProfile.DisableInputFilesWindow = true;

		if ( oProfile.CollectData(SIGN_WIZARD_TYPE) ) // it returns false when user cancel wizard
		{
			oProfile.SignIncludeBase64Headers = false;
			oProfile.Detach = isDetachedSign;
			//if ( oProfile.CheckData(SIGN_WIZARD_TYPE) ) // may be skipped if is called after .CollectData()
			//{
			//	throw "Not enough data (code: " + oProfile.CheckData(SIGN_WIZARD_TYPE) + ")!";
			//}

			oPKCS7Message.Import(DT_PLAIN_DATA, text); // loading of data
			oPKCS7Message.Profile = oProfile;
			oPKCS7Message.Sign(); // signing
			retStr = oPKCS7Message.Export(DT_SIGNED_DATA, BASE64_TYPE); // exporting of signed document
		}
	}
	catch(e)
	{ 
		alert("Exception catched: " + ((typeof e == "object") ? e.description : e));
	}

	return retStr;
}

function OnSignClicked()
{
	var form = document.form;

	var str = form.text_to_sign.value;
	if (str == "")
	{
		alert("No text found!");
		return;
	}

	var signed_text = SignText(str);
	if (signed_text == "")
	{
		alert("No signature found!");
		return;
	}

	form.signature.value = signed_text;
}

function OnSubmitClicked()
{
	var form = document.form;

	var str = form.signature.value;
	if (str == "")
	{
		alert("Put signature in Base64 format or press \"Sign\" for it's generating!");
		return;
	}

	form.submit();
}
//-->
</script>
</head>
<body>
<?
if (!isset($_REQUEST["signature"])) // begin of html part
{
?>
	&nbsp;web-form part<br/><br/>

	<form id="form" name="form" method="post" action="SignAndVerify.php">
	<table border="0" cellspacing="0" cellpadding="0" class="popup">
		<tr>
			<td>&nbsp;Enter a text:&nbsp;</td>
			<td><input type="text" id="text_to_sign" name="text_to_sign" value="" size="40"></td>
		</tr>
		<tr>
			<td>&nbsp;Enter a signature:&nbsp;</td>
			<td><textarea id="signature" name="signature" rows="20" cols="80"></textarea></td>
		</tr>
		<tr>
			<td colspan="2">
			<input type="button" name="btnSign" value="Sign" onclick="OnSignClicked();">
			<input type="button" name="btnSend" value="Submit" onclick="OnSubmitClicked();">
			</td>
		</tr>
	</table>
	</form>
<?
}
else // end of html and begin of php-java part
{
	echo "php-java part<br/><br/>";

	define('JAVA_HOSTS', "localhost:8080");
	//define('JAVA_SERVLET', false);
	//require_once("http://localhost:8080/JavaBridge/java/Java.inc");
	require_once("JavaBridge/java/Java.inc");

	//phpinfo();

	function verifyCertificate($cert)
	{
		// looking for issuer ceritificate
		$certRoot = null;

		$storeCsp = new java("com.digt.trusted.jce.provider.CryptoProCSPCertStore");
		$store = $storeCsp->getInstance("CurrentUser/Root", null);
		$certsRoot = $store->getAllCertificates();
		$iterRootCert = $certsRoot->iterator();
		while (java_values($iterRootCert->hasNext()))
		{
			$certRootCur = $iterRootCert->next();
			if ( java_values($certRootCur->getSubjectDN()->equals($cert->getIssuerDN())) )
			{
				if (( !java_is_null($certRootCur->getSubjectUniqueID()) )
					&& ( !java_is_null($cert->getIssuerUniqueID()) ))
				{
					if ( $certRootCur->getSubjectUniqueID() != $cert->getIssuerUniqueID() )
					{
						//echo "Info: Issuer certificate does not match (by IDs)";
						continue;
					}
				}
				else
				{
					try
					{
						$cert->verify($certRootCur->getPublicKey(), "DIGT");
					}
					catch (Exception $ex)
					{
						//echo "Info: Issuer certificate does not match: <pre>"; echo $ex; echo "</pre><br>\n";
						continue;
					}
				}

				$certRoot = $certRootCur;
				break;
			}
		}

		// checking of root certificate
		if ( !$certRoot )
			throw new Exception("Issuer certificate is not found");

		$pubKeyIssuer = $certRoot->getPublicKey();

		$certRoot->checkValidity();
		$certRoot->verify($pubKeyIssuer, "DIGT");

		// if certificate is not self signed then perform some another checks
		if (( !java_values($certRoot->getIssuerDN()->equals($cert->getSubjectDN())) )
			|| ( !java_values($certRoot->getSerialNumber()->equals($cert->getSerialNumber())) ))
		{
			// checking of client certificate
			$cert->checkValidity();
			$cert->verify($pubKeyIssuer, "DIGT");

			// looking for local CRL
			$crl = null;

			$store = $storeCsp->getInstance("CurrentUser/CA", null);
			$crls = $store->getAllCRLs();
			$iterCrl = $crls->iterator();
			while ( java_values($iterCrl->hasNext()) )
			{
				$crlCur = $iterCrl->next();

				if ( java_values( $crlCur->getIssuerDN()->equals($cert->getIssuerDN()) )
					&& (( null == $crl )
						|| ( java_values($crl->getThisUpdate()->before($crlCur->getThisUpdate())) )))
				{
					try
					{
						$crlCur->verify($pubKeyIssuer, "DIGT");
					}
					catch (Exception $ex)
					{
						//echo "Info: CRL does not match: <pre>"; echo $ex; echo "</pre><br>\n";
						continue;
					}

					$crl = $crlCur;
					break;
				}
			}

			// checking of CRL
			if ( null == $crl )
				throw new Exception( "No one CRL was found" );
			if ( java_values($crl->getNextUpdate()->before(new java("java.util.Date"))) )
				throw new Exception( "CRL expired" );
			$crl->verify($pubKeyIssuer, "DIGT");

			// looking of cert in CRL
			$crlEntry = $crl->getRevokedCertificate($cert);
			if ( !java_is_null($crlEntry) )
				throw new Exception( "Certificate in CRL" );
		}

		return true;
	}

	try
	{
		$digtProvider = new java("com.digt.trusted.jce.provider.DIGTProvider");

		java("java.security.Security")->addProvider($digtProvider);

		if (false) // read from file or web form
		{
			$fileInputStream = new java("java.io.FileInputStream", "/tmp/test.pem");
			$inputStreamReader = new java("java.io.InputStreamReader", $fileInputStream);
			$dataIn = new java("java.io.BufferedReader", $inputStreamReader);

			$buf = null;
			$sigData = new java("java.lang.StringBuilder");
			while (!java_is_null($buf = $dataIn->readLine()))
			{
				$sigData->append($buf);
			}
			$sigData = $sigData->toString();
		}
		else
		{
			$sigData = new java("java.lang.String", $_REQUEST["signature"]);
		}

		$sigBytes = java("com.digt.trusted.util.encoders.Base64")->decode($sigData);
		$byteIn = new java("java.io.ByteArrayInputStream", $sigBytes);
		$aIn = new java("com.digt.trusted.asn1.ASN1InputStream", $byteIn);

		$testDataString = new java("java.lang.String", $_REQUEST["text_to_sign"]);
		$testDataString = $testDataString->getBytes("UTF-16LE"); // converting to Window's UNICODE

		$data = new java("com.digt.trusted.cms.CMSProcessableByteArray", $testDataString);
		$sig = new java("com.digt.trusted.cms.CMSSignedData", $data, java("com.digt.trusted.asn1.cms.ContentInfo")->getInstance($aIn->readObject()));

		$certs = $sig->getCertificatesAndCRLs("Collection", "DIGT");
		$signers = $sig->getSignerInfos();

		$c = $signers->getSigners();
		echo "Count of signers: " . java_values($c->size()) . "<br/>";

		$it = $c->iterator();
		while (java_values($it->hasNext()))
		{
			$signer = $it->next();

			// printing of signer's information
			echo "<br/>Signer's information:<br/>";
			echo "Digest algorithm: " . java_values($signer->getDigestAlgOID()) . "<br/>";

			// printing of signer certificates's information
			$certCollection = $certs->getCertificates($signer->getSID());
			$certIt = $certCollection->iterator();
			$cert = $certIt->next();

			echo "Certificate's issuer DN: " . java_values($cert->getIssuerDN()->toString()) . "<br/>";
			echo "Certificate's subject DN: " . java_values($cert->getSubjectDN()->toString()) . "<br/>";
			echo "Certificate's serial number: 0x" . java_values($cert->getSerialNumber()->toString(16)) . "<br/>";
			//echo "Certificate's validity: " . java_values($cert->getNotBefore()->toString()) . " - " . java_values($cert->getNotAfter()->toString()) . "<br/>";

			$eku = $cert->getExtendedKeyUsage();
			if ( java_is_null($eku) )
			{
				echo "Certificate's EKU: certificate is universal (extension is absent)<br/>";
			}
			else
			{
				echo "Certificate's EKU: " . java_values($eku->toString()) . "<br/>";
			}

			// printing of signature's cryptographic verification status
			try
			{
				$bSignStatus = $signer->verify($cert, "DIGT");
			}
			catch (Exception $ex)
			{
				echo "An exception occured: <pre>"; echo $ex; echo "</pre><br>\n";
				$bSignStatus = false;
			}
			echo "Signature is " . ($bSignStatus ? "valid" : "INVALID!!!") . "<br/>";

			// printing of signer certificate's verification status
			try
			{
				$bCertStatus = verifyCertificate($cert);
			}
			catch (Exception $ex)
			{
				echo "An exception occured: <pre>"; echo $ex; echo "</pre><br>\n";
				$bCertStatus = false;
			}
			echo "Signer certificate is " . ($bCertStatus ? "valid" : "INVALID!!!") . "<br/>";
		}

		if ( isset($dataIn) )
		{
			$dataIn->close();
		}
	}
	catch (Exception $ex)
	{
		echo "An exception occured: <pre>"; echo $ex; echo "</pre><br>\n";
	}
} // end of php-java part
?>
</body>
</html>
